#  Copyright (c) 2018 Victor Porton,
#  XML Boiler - http://freesoft.portonvictor.org
#
#  This file is part of XML Boiler.
#
#  XML Boiler is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Affero General Public License as
#  published by the Free Software Foundation, either version 3 of the
#  License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Affero General Public License for more details.
#
#  You should have received a copy of the GNU Affero General Public License
#  along with this program. If not, see <http://www.gnu.org/licenses/>.


class Timeout(Exception):
    pass


class BaseCommandRunner(object):
    @classmethod
    def run_pipe(cls, args, input, timeout=None, timeout2=None):
        """
        :param args: like `["ls", "-l"]`
        :param input: input string
        :param timeout: before sending SIGTERM
        :param timeout2: additional timeout before sending SIGKILL
        :return: return code, output string

        May raise OSError
        """
        pass
